<template>
  <v-dialog width="75%" height="75%" v-model="drawer" scrollable persistent>
    <v-card>
      <v-card-title class="d-flex">
        <v-sheet class="me-auto">Member Management</v-sheet>
        <v-sheet
          ><v-btn
            icon="$close"
            density="comfortable"
            variant="plain"
            @click="close"
          ></v-btn
        ></v-sheet>
      </v-card-title>
      <v-card-text>
        <h1></h1>
        <h3 class="mb-3">
          Members
          <v-chip size="small" class="me-2">{{
            InvestigationMembers.length
          }}</v-chip>
          <v-icon size="small" @click="getMembers">mdi-reload</v-icon>
        </h3>
        <v-btn
          size="small"
          color="primary"
          @click="investigationAddMembersDialog = true"
          >Add members</v-btn
        >

        <v-table density="compact">
          <thead>
            <tr>
              <th class="text-left">Username</th>
              <th class="text-left">Name</th>
              <th class="text-left">Email</th>
              <th class="text-left">Role</th>
              <th class="text-left">Action</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="member in InvestigationMembers" :key="member.username">
              <td>{{ member.username }}</td>
              <td>{{ member.first_name }} {{ member.last_name }}</td>
              <td>
                <a :href="`mailto:` + member.email_adress">{{
                  member.email_adress
                }}</a>
              </td>
              <td>
                <v-select
                  density="compact"
                  hide-details="true"
                  v-model="member.role"
                  :items="dialog_roles"
                  :item-props="itemProps"
                  @update:modelValue="changeRole(member)"
                  :disabled="session.userMadbot.username == member.username"
                ></v-select>
              </td>
              <td>
                <v-btn
                  icon="mdi-delete"
                  variant="text"
                  :disabled="session.userMadbot.username == member.username"
                  @click="deleteMemberConfimation(member.username)"
                ></v-btn>
              </td>
            </tr>
          </tbody>
        </v-table>
      </v-card-text>
    </v-card>
  </v-dialog>

  <InvestigationsAddMembers
    :investigationAddMembersDialog="investigationAddMembersDialog"
    @investigationAddMembersDialog="investigationAddMembersDialog = false"
    @newMember="newMember = true"
  />

  <v-dialog v-model="dialogDelete" width="auto">
    <v-card>
      <v-card-title><v-icon>mdi-delete</v-icon> Delete a member</v-card-title>
      <v-card-text>
        You're about to remove <code>{{ memberToDelete }}</code> from
        investigation. Are you sure?
      </v-card-text>
      <v-card-actions class="d-flex flex-row-reverse">
        <v-btn color="error" @click="deleteMember()"> Yes </v-btn>
        <v-btn
          color="success"
          @click="
            dialogDelete = false;
            memberToDelete = '';
          "
          >Cancel</v-btn
        >
      </v-card-actions>
    </v-card>
  </v-dialog>

  <Snackbar
    :text="snackbarMessage"
    :type="snackbarMessageType"
    @messageDisplayed="
      snackbarMessage = null;
      snackbarMessageType = null;
    "
  />
</template>

<script>
import { useISAStore } from "@/stores/useISAStore";

export default {
  props: {
    investigationParametersDialog: {
      required: true,
    },
  },
  setup() {
    const { data: session } = useSession();
    const ISAStore = useISAStore();
    const investigationAddMembersDialog = ref(false);
    const newMember = ref(false);
    return { investigationAddMembersDialog, ISAStore, newMember, session };
  },
  data() {
    return {
      drawer: null,
      countMembers: 0,
      InvestigationMembers: [],
      snackbarMessage: null,
      snackbarMessageType: null,
      dialogDelete: false,
      memberToDelete: "",
      dialog_roles: [],
    };
  },
  async mounted() {
    await this.getMembers();
    await useAPIFetch("/api/members/description/roles").then((response) => {
      this.dialog_roles = response.data;
    });
  },
  emits: ["investigationParametersDialog"],
  watch: {
    async investigationParametersDialog(newValue) {
      await this.getMembers();
      this.drawer = newValue;
    },
    async newMember(newValue) {
      if (this.newMember) {
        await this.getMembers();
        this.newMember = false;
      }
    },
  },
  methods: {
    // The `close()` method is a function that is called when the close button is
    // clicked in the dialog. It sets the `drawer` property to `false`, which
    // closes the dialog. It also emits an event called
    // "investigationParametersDialog" with a value of `false`, indicating that the
    // dialog should be closed in the parent component.
    close() {
      this.drawer = false;
      this.$emit("investigationParametersDialog", false);
    },
    // The `itemProps` method is a function that takes an `item` as a parameter and
    // returns an object with `title` and `subtitle` properties. This method is
    // used as a callback function for the `v-select` component in the Vue
    // template.
    itemProps(item) {
      return {
        title: item.role,
        subtitle: item.description,
      };
    },
    // The `changeRole` method is an asynchronous function that is called when the
    // role of a member is changed in the Vue component.
    async changeRole(member) {
      await useAPIFetch(
        "/api/investigations/" +
          this.ISAStore.currentInvestigation.id +
          "/members/username:" +
          member.username +
          "/",
        {
          method: "PUT",
          body: {
            role: member.role.role,
          },
        }
      );

      this.snackbarMessage = "Role changed successfully";
      this.snackbarMessageType = "success";
    },
    // The `getMembers()` method is an asynchronous function that retrieves the
    // list of members for a specific investigation.
    async getMembers() {
      const { data: InvestigationMembers } = await useAPIFetch(
        "/api/investigations/" +
          this.ISAStore.currentInvestigation.id +
          "/members/"
      );
      this.InvestigationMembers = InvestigationMembers;
      this.countMembers = InvestigationMembers.length;
    },
    // The `deleteMemberConfimation(username)` method is setting the `dialogDelete`
    // property to `true` and assigning the `username` parameter to the
    // `memberToDelete` property. This method is called when the delete button is
    // clicked for a member in the table. It prepares the dialog box for member
    // deletion by setting the necessary properties.
    deleteMemberConfimation(username) {
      this.dialogDelete = true;
      this.memberToDelete = username;
    },
    // The `deleteMember()` method is an asynchronous function that is called when
    // a member is being deleted from the investigation.
    async deleteMember() {
      await useAPIFetch(
        "/api/investigations/" +
          this.ISAStore.currentInvestigation.id +
          "/members/username:" +
          this.memberToDelete +
          "/",
        {
          method: "DELETE",
        }
      ).then((res) => {
        const error = res.error.value;
        if (error) {
          this.snackbarMessage = res.error.value.data.Message;
          this.snackbarMessageType = "error";
        } else {
          this.snackbarMessage =
            "The member " +
            this.memberToDelete +
            " has been removed from the investigation";
          this.snackbarMessageType = "error";

          this.getMembers();
        }
        this.memberToDelete = "";
        this.dialogDelete = false;
      });
    },
  },
};
</script>
